from __future__ import annotations
from kiota_abstractions.serialization import AdditionalDataHolder, Parsable, ParseNode, SerializationWriter
from typing import Any, Callable, Dict, List, Optional, TYPE_CHECKING, Union

class DownloadRef(AdditionalDataHolder, Parsable):
    """
    Models a download "link".  Useful for browser use-cases.
    """
    def __init__(self,) -> None:
        """
        Instantiates a new DownloadRef and sets the default values.
        """
        # Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
        self._additional_data: Dict[str, Any] = {}

        # The downloadId property
        self._download_id: Optional[str] = None
        # The href property
        self._href: Optional[str] = None
    
    @property
    def additional_data(self,) -> Dict[str, Any]:
        """
        Gets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
        Returns: Dict[str, Any]
        """
        return self._additional_data
    
    @additional_data.setter
    def additional_data(self,value: Dict[str, Any]) -> None:
        """
        Sets the additionalData property value. Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
        Args:
            value: Value to set for the AdditionalData property.
        """
        self._additional_data = value
    
    @staticmethod
    def create_from_discriminator_value(parse_node: Optional[ParseNode] = None) -> DownloadRef:
        """
        Creates a new instance of the appropriate class based on discriminator value
        Args:
            parseNode: The parse node to use to read the discriminator value and create the object
        Returns: DownloadRef
        """
        if parse_node is None:
            raise Exception("parse_node cannot be undefined")
        return DownloadRef()
    
    @property
    def download_id(self,) -> Optional[str]:
        """
        Gets the downloadId property value. The downloadId property
        Returns: Optional[str]
        """
        return self._download_id
    
    @download_id.setter
    def download_id(self,value: Optional[str] = None) -> None:
        """
        Sets the downloadId property value. The downloadId property
        Args:
            value: Value to set for the download_id property.
        """
        self._download_id = value
    
    def get_field_deserializers(self,) -> Dict[str, Callable[[ParseNode], None]]:
        """
        The deserialization information for the current model
        Returns: Dict[str, Callable[[ParseNode], None]]
        """
        fields: Dict[str, Callable[[Any], None]] = {
            "downloadId": lambda n : setattr(self, 'download_id', n.get_str_value()),
            "href": lambda n : setattr(self, 'href', n.get_str_value()),
        }
        return fields
    
    @property
    def href(self,) -> Optional[str]:
        """
        Gets the href property value. The href property
        Returns: Optional[str]
        """
        return self._href
    
    @href.setter
    def href(self,value: Optional[str] = None) -> None:
        """
        Sets the href property value. The href property
        Args:
            value: Value to set for the href property.
        """
        self._href = value
    
    def serialize(self,writer: SerializationWriter) -> None:
        """
        Serializes information the current object
        Args:
            writer: Serialization writer to use to serialize this model
        """
        if writer is None:
            raise Exception("writer cannot be undefined")
        writer.write_str_value("downloadId", self.download_id)
        writer.write_str_value("href", self.href)
        writer.write_additional_data_value(self.additional_data)
    

